﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Santa_Simulator
{
    public partial class Game : UserControl
    {
        bool insideLoaded = false;
        int scale = 0;
        List<house> houses = new List<house>();

        int X = 0;
        int Y = 0;
        int startingY = 0;
        int right, left, up, down = 0;
        bool inside, twonow, finished, start3d, initialized = false;
        int score = 0;
        int time = 180;
        Random r = new Random();

        Form1 _mainform;
        public Game(Form1 mainform)
        {
            InitializeComponent();
            _mainform = mainform;
            Timer.Start();
            furnaceAnimation.Start();
            thatFatGuy.Image = Image.FromFile($@"{AppDomain.CurrentDomain.BaseDirectory}" + @"_SantaRight.png");
            loadHouses();
            while (thatFatGuy.Left + 40 > HousePic.Left && thatFatGuy.Top + 85 > HousePic.Top && thatFatGuy.Left < HousePic.Left + (int)(300f * (float)(scale / 100f)) && thatFatGuy.Top < HousePic.Top + (int)(200f * (float)(scale / 100f)))
            {
                thatFatGuy.Left = r.Next(5, 741);
                thatFatGuy.Top = r.Next(70, 432);
            }
            initialized = true;
        }
        private void KDown(object sender, KeyEventArgs e)
        {
            switch (e.KeyCode)
            {
                case Keys.W:
                    if (left == 0 && right == 0 && up == 0 && down == 0)
                    {
                        up = 10;
                    }
                    break;
                case Keys.A:
                    if (left == 0 && right == 0 && down == 0 && up == 0)
                    {
                        left = 10;
                    }
                    break;
                case Keys.D:
                    if (right == 0 && left == 0 && down == 0 && up == 0)
                    {
                        right = 10;
                    }
                    break;
                case Keys.S:
                    if (down == 0 && left == 0 && right == 0 && down == 0)
                    {
                        down = 10;
                    }
                    break;
            }
        }

        private void animate(object sender, EventArgs e)
        {
            if (twonow)
            {
                Furnace.Image = Image.FromFile($@"{AppDomain.CurrentDomain.BaseDirectory}" + @"_FurnaceFrame2.png");
                twonow = false;
            }else
            {
                Furnace.Image = Image.FromFile($@"{AppDomain.CurrentDomain.BaseDirectory}" + @"_FurnaceFrame1.png");
                twonow = true;
            }
        }

        private void removeTime(object sender, EventArgs e)
        {
            time--;
        }

        private void started(object sender, MouseEventArgs e)
        {
            if (!start3d)
            {
                infoLabel.Visible = false;
                uselessThing.Visible = false;
                uselessThing2.Visible = false;
                timeRemaining.Start();
                BackgroundImage = null;
                start3d = true;
            }
        }

        private void goBack_Click(object sender, EventArgs e)
        {
            if (!File.Exists("highscore"))
            {
                File.AppendAllText("highscore", score.ToString());
            }
            else
            {
                if (score > int.Parse(File.ReadAllText("highscore")))
                {
                    File.WriteAllText("highscore", score.ToString());
                }
            }
            _mainform.showMenu();
        }

        private void Tick(object sender, EventArgs e)
        {
            int startX = thatFatGuy.Left;
            int startY = thatFatGuy.Top;
            ScoreLabel.Text = "Score: " + score;
            TimeLabel.Text = "Time: " + time;
            if (right != 0)
            {
                thatFatGuy.Left += (int)(right / 1.5f);
                if (right == 10)
                {
                    startingY = thatFatGuy.Top;
                }
                int randomNumber = r.Next(1, 3);
                right -= randomNumber;
                thatFatGuy.Top -= right - 5;
                if(randomNumber == 2)
                {
                    thatFatGuy.Top -= (right - 4);
                }
                thatFatGuy.Image = Image.FromFile($@"{AppDomain.CurrentDomain.BaseDirectory}" + @"_SantaRight.png");
                if (right <= 0)
                {
                    right = 0;
                    thatFatGuy.Top = startingY;
                }
            }
            if (left != 0)
            {
                thatFatGuy.Left -= (int)(left / 1.5f);
                if (left == 10)
                {
                    startingY = thatFatGuy.Top;
                }
                int randomNumber = r.Next(1, 3);
                left -= randomNumber;
                thatFatGuy.Top -= left - 5;
                if (randomNumber == 2)
                {
                    thatFatGuy.Top -= (left - 4);
                }
                thatFatGuy.Image = Image.FromFile($@"{AppDomain.CurrentDomain.BaseDirectory}" + @"_SantaLeft.png");
                if (left <= 0)
                {
                    left = 0;
                    thatFatGuy.Top = startingY;
                }
            }
            if (up != 0)
            {
                thatFatGuy.Top -= (int)(up / 1.5f);
                up -= r.Next(1, 3);
                if (up < 0)
                {
                    up = 0;
                }
            }
            if (down != 0)
            {
                thatFatGuy.Top += (int)(down / 1.5f);
                down -= r.Next(1, 3);
                if (down < 0)
                {
                    down = 0;
                }
            }
            if (thatFatGuy.Left > 760)
            {
                if (!inside)
                {
                    thatFatGuy.Left = -9;
                    X++;
                    loadHouses();
                }else
                {
                    thatFatGuy.Left = 760;
                }
            }
            if (thatFatGuy.Left < -10)
            {
                if (!inside)
                {
                    thatFatGuy.Left = 759;
                    X--;
                    loadHouses();
                }else
                {
                    thatFatGuy.Left = -10;
                }
            }

            if (thatFatGuy.Top > 386)
            {
                if (!inside)
                {
                    thatFatGuy.Top = -9;
                    Y--;
                    loadHouses();
                }else
                {
                    thatFatGuy.Top = 386;
                }
            }
            if (thatFatGuy.Top < -10)
            {
                if (!inside)
                {
                    thatFatGuy.Top = 385;
                    Y++;
                    loadHouses();
                }else
                {
                    thatFatGuy.Top = -10;
                }
            }
            if (inside)
            {
                if (thatFatGuy.Left + 40 > ChristmasTree.Left && thatFatGuy.Top + 85 > ChristmasTree.Top && thatFatGuy.Left < ChristmasTree.Left + 100 && thatFatGuy.Top < ChristmasTree.Top + 150)
                {
                    thatFatGuy.Left = startX;
                    thatFatGuy.Top = startY;
                    if (!finished && insideLoaded)
                    {
                        finished = true;
                        ChristmasTree.Image = Image.FromFile($@"{AppDomain.CurrentDomain.BaseDirectory}" + @"_Gifts.png");
                        score++;
                    }
                }

                if (thatFatGuy.Left + 40 > Furnace.Left && thatFatGuy.Top + 85 > Furnace.Top && thatFatGuy.Left < Furnace.Left + 100 && thatFatGuy.Top < Furnace.Top + 100)
                {
                    if (!finished && insideLoaded)
                    {
                        thatFatGuy.Left = startX;
                        thatFatGuy.Top = startY;
                    }
                    else
                    {
                        loadOutside();
                    }
                }
            }
            else
            {
                foreach (house h in houses)
                {
                    if (h.Xloc == X && h.Yloc == Y && h.isThere && initialized)
                    {
                        if (thatFatGuy.Left + 40 > HousePic.Left && thatFatGuy.Top + 85 > HousePic.Top && thatFatGuy.Left < HousePic.Left + (int)(300f * (float)(scale / 100f)) && thatFatGuy.Top < HousePic.Top + (int)(200f * (float)(scale / 100f)))
                        {
                            inside = true;
                            loadInside();
                        }
                    }
                }
            }
            if (time < 1)
            {
                Timer.Stop();
                furnaceAnimation.Stop();
                timeRemaining.Stop();
                timesUp.Visible = true;
                timesUp2.Visible = true;
                timesUp2.Text += score.ToString();
                goBack.Visible = true;
                uselessThing.Visible = true;

                thatFatGuy.Visible = false;
                ChristmasTree.Visible = false;
                Furnace.Visible = false;
                HousePic.Visible = false;
                BackColor = System.Drawing.Color.Black;
            }
        }
        void loadHouses()
        {
            bool found = false;
            foreach(house h in houses)
            {
                if (h.Xloc == X && h.Yloc == Y)
                {
                    HousePic.Left = h.Xpos;
                    HousePic.Top = h.Ypos;

                    HousePic.Width = (int)(300f * (float)(h.scale / 100f));
                    HousePic.Height = (int)(200f * (float)(h.scale / 100f));
                    if (h.completed)
                    {
                        HousePic.BackgroundImage = Image.FromFile($@"{AppDomain.CurrentDomain.BaseDirectory}" + @"_HouseCompleted.png");
                    }else
                    {
                        HousePic.BackgroundImage = Image.FromFile($@"{AppDomain.CurrentDomain.BaseDirectory}" + @"_HouseNotyet.png");
                    }
                    HousePic.BackgroundImageLayout = ImageLayout.Stretch;
                    scale = h.scale;
                    found = true;
                    HousePic.Visible = true;
                    if (h.isThere == false)
                        HousePic.Visible = false;
                }
            }

            if (!found)
            {
                HousePic.BackgroundImage = Image.FromFile($@"{AppDomain.CurrentDomain.BaseDirectory}" + @"_HouseNotyet.png");
                HousePic.Left = r.Next(10, 440);
                HousePic.Top = r.Next(10, 222);

                bool isThere = true;
                scale = r.Next(75, 125);
                HousePic.Width = (int)(300f * (float)(scale / 100f));
                HousePic.Height = (int)(200f * (float)(scale / 100f));
                if (r.Next(1, 5) == 1)
                    isThere = false;
                houses.Add(new house(HousePic.Left, HousePic.Top, X, Y, false, scale, r.Next(0, 691), r.Next(120, 312), r.Next(0, 691), isThere));

                HousePic.BackgroundImageLayout = ImageLayout.Stretch;
                HousePic.Visible = true;
                if (isThere == false)
                    HousePic.Visible = false;
            }
        }
        void loadInside()
        {
            stopMovement();
            insideLoaded = false;
            HousePic.Visible = false;
            bool completed = false;

            foreach (house h in houses)
            {
                if (h.Xloc == X && h.Yloc == Y)
                {
                    Furnace.Left = h.Furnace;
                    ChristmasTree.Left = h.TreeX;
                    ChristmasTree.Top = h.TreeY;
                    completed = h.completed;
                }
            }

            finished = false;
            Furnace.Visible = true;
            ChristmasTree.Visible = true;
            BackColor = System.Drawing.Color.DarkGoldenrod;
            if (completed)
            {
                finished = true;
                ChristmasTree.Image = Image.FromFile($@"{AppDomain.CurrentDomain.BaseDirectory}" + @"_Gifts.png");
            }else
            {
                ChristmasTree.Image = Image.FromFile($@"{AppDomain.CurrentDomain.BaseDirectory}" + @"_ChristmasTree.png");
            }
            thatFatGuy.Top = Furnace.Top;
            if (Furnace.Left > 395)
            {
                thatFatGuy.Left = Furnace.Left - 45;
            }else
            {
                thatFatGuy.Left = Furnace.Left + 145;
            }
            insideLoaded = true;
        }
        void loadOutside()
        {
            stopMovement();
            ChristmasTree.Visible = false;
            Furnace.Visible = false;
            HousePic.Visible = true;
            BackColor = System.Drawing.Color.MidnightBlue;
            inside = false;
            foreach (house h in houses)
            {
                if (h.Xloc == X && h.Yloc == Y)
                {
                    h.completed = true;
                    thatFatGuy.Left = h.Xpos - 50;
                    thatFatGuy.Top = h.Ypos + (int)(100f * (float)(h.scale / 100f));
                }
            }
            loadHouses();
            bool insideLoaded = false;
        }
        void stopMovement()
        {
            right = 0;
            up = 0;
            left = 0;
            down = 0;
        }
    }
}
